﻿<%@ Page Language="C#" Inherits="System.Web.Mvc.ViewPage<Addons.Evaluation.LinkDump>" Title="Manual creating UrlSelector" %>
<%@ Import Namespace="System.Web" %>
<%@ Import Namespace="EPiServer.Shell.Web.Mvc.Html" %>
<%@ Import Namespace="EPiServer.Framework.Web.Resources" %>
<%@ Import Namespace="EPiServer.Shell" %>
<%@ Import Namespace="EPiServer.Shell.Navigation" %>
<%@ Import Namespace="EPiServer" %>
<%@ Import Namespace="EPiServer.Web" %>
<%@ Import Namespace="EPiServer.Core" %>
<%@ Import Namespace="Addons.Evaluation" %>
<%@ Register TagPrefix="sc" Assembly="EPiServer.Shell" Namespace="EPiServer.Shell.Web.UI.WebControls" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Manual creating UrlSelector</title>
    <!-- Begin: Shell -->
    <asp:PlaceHolder ID="shellScripts" runat="server">

        <%--TECHNOTE: the order of scripts loading here must be like this BEGIN: --%>
        <%= Page.DojoConfig(true, true, false) %>
        <script type="text/javascript" src="<%= Paths.ToShellClientResource("ClientResources/dojo/dojo.js") %>"></script>
        <script type="text/javascript" src="<%= Paths.ToShellClientResource("ClientResources/epi/shell/widgets.js") %>"></script>   <%--combined script from shell--%>
        <script type="text/javascript" src="<%= Paths.ToClientResource("CMS", "ClientResources/epi-cms/widgets.js") %>"></script>   <%--combined script from cms--%>

        <%=Page.ClientResources("ShellCore")%>
        <%=Page.ClientResources("ShellWidgets")%>
        <script type="text/javascript" src="<%= Paths.ToShellClientResource("ClientResources/epi/epi.js") %>"></script> <%--combined script from EditView--%>

        <!-- Shell init script (for routing) -->
        <%= Html.ShellInitializationScript() %>
        <%--TECHNOTE: the order of scripts loading here must be like this END --%>

        <%--Using LightTheme, these lines can be remove if we need to minimize the CSS loading for SocialReach--%>
        <%=Page.ClientResources("ShellCoreLightTheme")%>
        <%=Page.ClientResources("ShellWidgetsLightTheme")%>
        <%=Page.ClientResources("Navigation")%> <%--Load JS for handling Report dialog in GlobalNavigation--%>
        <%= Html.CssLink(EPiServer.Web.PageExtensions.ThemeUtility.GetCssThemeUrl(Page, "ToolButton.css"))%>

    </asp:PlaceHolder>
    <%= Page.ClientResources("epi.shell.ui", new[] { ClientResourceType.Style }) %>
    <%= Page.ClientResources("epi-cms.widgets.base", new[] { ClientResourceType.Style }) %>
    <!-- End: Shell -->
        
   
    <script type="text/javascript">
        // global variables for clientside script
        var g_ProtectedRootPath = '<%= Paths.ProtectedRootPath %>';
        var g_ModulesPath = '<%= Paths.PublicRootPath %>';

        var g_EPiServer = {
            siteUrl: '<%= SiteDefinition.Current.SiteUrl.ToString() %>',
            siteAssetsRootID: <%= SiteDefinition.Current.SiteAssetsRoot.ID %>,
            globalAssetsRootID: <%= SiteDefinition.Current.GlobalAssetsRoot.ID %>,
            rootPageID: <%= EPiServer.Core.ContentReference.RootPage.ID %>,
            contentAssetsRootID: <%= SiteDefinition.Current.ContentAssetsRoot.ID %>
        };
    </script>

</head>
<body>
    <form id="form1" runat="server">
    <div>
        <div runat="server">
            <div class="epi-globalNavigationContainer">
                <sc:ShellMenu runat="server" SelectionPath="/global/social/outreach" />
            </div>
        </div>
        <div class="outreach">
        
            <div class="heading">
                <h1>Heading goes here!</h1>
            </div>
        <div>
                <input id="socialmessage-current-language-id" type="hidden" />
        
                <div>
                    <label for="socialmessage-url">Select a link</label>
                    <div id="socialmessage-linkSelector" class="linkSelector"></div>
                    <input id="socialmessage-url" type="hidden" />
                </div>
            </div>
        </div>
    <script type="text/javascript">
        // Serialize initial object to JSON for clientside script consuming
        var g_DefaultDump = <%= Model.ToJson() %>;
    </script>
    <script src="<%= Paths.ToClientResource(Model.GetType(), "ClientResources/Scripts/TestUrlSelector.js") %>" type="text/javascript"></script>

    </div>
    </form>
</body>
</html>
